// MSP430-CQigWX^ZpQOOVDPt^j
// PWMɂLED_ł̃eXg
//
// Output P1.0(CN2-22) : LEDo(Hi=_, Low=)OtPullDownRKv
//
// MCLK=94 x ACLK x 2 = 6.160MHz
// gp^C}[ : TimerA0gp(NbN=SMCLK) f[eB[쐬
// gp^C}[ : WDTgp(NbN=ACLK) PWMg
// gp^C}[ : BasicTimergp(NbN=ACLK) 1msec҂ԃEGCg
//
// RpCFTI MSP430p IAR Embedded Workbench iEW430jo[W3.41
// RpCFmspgcc
//
//  
// 2007.1.30

#include "hardware.h"
#include "lcd.h"

#define DTY_MIN 0
#define DTY_MAX 128
#define DIV (DTY_MAX-DTY_MIN)

volatile unsigned short pwm_dty=0;
volatile unsigned short idx=0;

//Timer A0 ݃[`
#ifdef __GNUC__  //GNU Cp
  wakeup interrupt (TIMERA0_VECTOR) INT_TimerA_CCR0(void)
#else  //EW430p
  #pragma vector=TIMERA0_VECTOR
  __interrupt void INT_TimerA_CCR0 (void)
#endif
{
  if(idx<pwm_dty){
    idx++;
  }
  else{
    CCTL0 &= ~CCIE;//Timer A0荞݃fBZ[u
    P1OUT &= ~0x01;//LED OFF
  }
}

//WDT݃[`
#ifdef __GNUC__  //GNU Cp
  wakeup interrupt (WDT_VECTOR) INT_WDT(void)
#else  //EW430p
  #pragma vector=WDT_VECTOR
  __interrupt void INT_WDT (void)
#endif
{
  P1OUT |= 0x01;//LED ON
  TAR = 0;//CCR0 * pwm_dty / DIV;//128
  idx=0;
  CCTL0 = CCIE;//Timer A0荞݃Cl[u
}

//  1ms~datԑ҂ٰ
void t1ms(unsigned short dat)             // Basic Timer1
{
  unsigned short j;
  unsigned long i;

  if(dat==0) return;
  
  i = 32.768 * dat - 2;                    // ACLK(32.768kHz)o߃JEgvZ
                                          // 22͎Ԓp(MCLK=1.048MHẑƂ)
                                          // 2͎Ԓp(MCLK=6.16MHẑƂ)
  do
  {
    j = BTCNT1;                           // j͉ʂ̃JE^l
    while(BTCNT1 == j);                   // BTCNT1JEgAbv܂ő҂
    i--;                                  // iPJEg
  }while (i != 0);                        // i=0(^CAbv)܂ŌJԂ
}

//itoaǂ
//w肪Ƃketa=0
//Xy[X̌wketa>0
//O([)̌wketa<0
char *itoa(long num, char *str, int keta)
{
  long wkn;
  int j,i,zero;
  char c;

  if(num<0L) {
    *str++='-';
    num = -num;
  }
  
  if(keta<0){
    zero=1;//O([)
    keta = -keta;  
  }
  else if(keta>0){
    zero=0;//Xy[X
  }

  if(keta>0){//w肠
    wkn=num;
    for(j=0;j<keta;j++){
      str[j]=(wkn%10L)+'0';//Pڂ珇Ԃɑ傫܂ŕĂ(t)
      if(j>0 && zero==0 && wkn==0L) str[j]=' ';//Qڈȍ~ŃXy[X̏ꍇ
      wkn=wkn/10L;
    }
  }
  else if(keta==0){//wȂ
    wkn=num;
    for(j=0;;j++){
      str[j]=(wkn%10L)+'0';//Pڂ珇Ԃɑ傫܂ŕĂ(t)
      wkn=wkn/10L;
      keta=j+1;
      if(wkn==0) break;//傫OɂȂ
    }  
  }
  
  for(i=0;i<(int)(keta/2);i++){//傫ƏtȂ̂œւ
    c=str[i];
    str[i]=str[keta-i-1];
    str[keta-i-1]=c;
  }

  str+=keta;//|C^Ō̕{Pɂ
  *str=0;//NULL
  return(str);  
}

//sprintfǂ
//str:ݐ̕|C^
//frm:tH[}bg̕|C^
//a[]:longlz
//
// frm
// %d
// %nd (n1ȏ̌AȂƂ̎g͂܂)
// %0nd (n1ȏ̌AȂƂ̎g͂܂)
// @long a; a[0] = 12L; a[1]=34L;
//     yyprintf(str, "v1=%d , v2=%4d", a);
//     str "v1=12 , v2=  34"ƂȂ܂ 
// @long a; a[0] = 12L; a[1]=34L;
//     yyprintf(str, "v1=%d , v2=%04d", a);
//     str "v1=12 , v2=0034"ƂȂ܂ 
void yyprintf(char *str, char *frm, long a[])
{
  int i,k,n,s;
  char *p,*oldp;
  
  k=i=n=0;
  for(;;){
    if(frm[i]!='%'){//Ŏn܂鐔ltH[}bgłȂƂ
      str[k]=frm[i];//PRs[
      k++;
      i++;
    }
    else{//Ŏn܂鐔ltH[}bĝƂ
      i++;//̎̕ɐi߂
      if(frm[i]=='d'){//w薳
        oldp=&str[k];
        p=itoa(a[n],&str[k],0);
        k+=(int)(p-oldp);
        i++;//̕
        n++;
      }
      else if('0'<=frm[i] && frm[i]<='9'){//Xy[XAOťw
        if('0'==frm[i]){
          i++;//O̕
          s=-1;//Ot
        }
        else s=1;//Xy[X
        
        oldp=&str[k];
        p=itoa(a[n],&str[k],s * (frm[i]-'0'));
        k+=(int)(p-oldp);
        i++;//l̕
        i++;//̕
        n++;
      }
    }
    if(frm[i]==0)
      break;//I
  }
  str[k]=0;//NULL
}

//g̐ݒƕ\
//f:ݒg
void SetFreq(long f)
{
  long ccr0;
  double mclk;
  double aclk;
  char str[17];
  long n[1];

   if(f>0L){
    aclk = 32768.0;//32768Hz
    mclk = (SCFQCTL + 1.0) * aclk * 2.0;//^C}[g (vZMCLK̐ݒɂ)
//  mclk = 6160677.5;//MCLK[q璼ڌvł͂ɂǂ
    ccr0 = (mclk / f) - 1.0;
    if(0<ccr0 && ccr0<=0xffff){//ݒłꍇ
      CCR0 = ccr0;
    }
    else{
      f = 0;
    }
  }

  #define cstr1 " PWM f=%dHz"
  #define cstr2 "duty div=%d"
  
  lcd_cls();
  n[0]=f / DIV;
  yyprintf(str, (char *)cstr1, n);
  lcd_gotopos(0,0);//lcd\ʒux=0,y=0
  lcd_putstr((unsigned char *)str);

  n[0]=DIV;
  yyprintf(str, (char *)cstr2, n);
  lcd_gotopos(0,1);//lcd\ʒux=0,y=1
  lcd_putstr((unsigned char *)str);
}

int main( void )
{
  long i,k;
  long freq;
  long wkdty;
  
  WDTCTL = WDTPW + WDTHOLD;//WDT̒~
  P1DIR |= BIT0;//P1.0,CN2-22o͂ɐݒiLED)
  P1OUT &= ~0x01;//LED OFF

  //MCLKpiMCLK[qo͂̂ő肵ȂƂ͕K̂QsRgɂj
//  P1DIR |= BIT1;//P1.1(MCLK),CN2-21o͂ɐݒ
//  P1SEL |= BIT1;//P1.1(MCLK),CN2-21MCLKɐݒ

  //ACLKpiACLK[qo͂̂ő肵ȂƂ͕K̂QsRgɂj
//  P1DIR |= BIT5;//P1.5(MCLK),CN2-17o͂ɐݒ
//  P1SEL |= BIT5;//P1.5(MCLK),CN2-17ACLKɐݒ
  
  lcd_init();//lcd
  lcd_cls();//lcd\NA
  
  //MCLK=94 x ACLK x 2 = 6.160MHz
  SCFQCTL = 94 - 1;//MCLK=94 x ACLK x 2 = 6.16MHz
  FLL_CTL0 = DCOPLUS + XCAP18PF;//DCOPLUS = 1, eʕׂ18pF
  SCFI0 = FLLD_2 + FN2;//D=2, 2.2`17MHz
  
  freq = (long)512 * (long)DIV;//f[eB[쐬pg
  SetFreq(freq);
  
  WDTCTL = WDT_ADLY_1_9;//WDT̃C^[o[hݒ 1.9msec (fACLK=32KHẑƂ)
  IE1 |= WDTIE;//WDT݃Cl[u

  TACTL = TASSEL_2 + MC_1;//SMCLK, Up to CCR0
  CCTL0 &= ~CCIE;//Timer A0荞݃fBZ[u

  BTCTL = BT_ADLY_2000;// Basic Timer̃NbNACLK/256
 
  _BIS_SR(GIE);//݋

   while(1){
    //Â疾邢
    for(i=DTY_MIN;i<DTY_MAX;i++){
      wkdty = (i*i)/(long)DTY_MAX;//l悤ȋȐɂ
      pwm_dty = (wkdty < DTY_MAX) ? wkdty : DTY_MAX-1;
      t1ms(5);//msecԑ҂
    }

    //邢ێEGCg
    k = ((BTCNT1 & 0x1) + 2) * 1000;//_ȑ҂ԂQbRb
    t1ms(k);//msecԑ҂

    //邢Â    
    for(i=DTY_MAX-1;i>=DTY_MIN;i--){
      wkdty = (i*i)/(long)DTY_MAX;//l悤ȋȐɂ
      pwm_dty = (wkdty < DTY_MAX) ? wkdty : DTY_MAX-1;
      t1ms(5);//msecԑ҂
    }

    IE1 &= ~WDTIE;//WDT݃fBZ[u
    P1OUT &= ~0x01;//LEDS
    //ÂێEGCg
    k = ((BTCNT1 & 0x1) + 1) * 1000;//_ȑ҂ԂPbQb
    t1ms(k);//msecԑ҂
    IE1 |= WDTIE;//WDT݃Cl[u
  }

  return 0;
}



